﻿Public Class populacao
    Inherits Collections.CollectionBase



    Private ObjCodigoHashtable As New Hashtable

    Private ObjNomeHashtable As New Hashtable



    Private _count As Integer





    Public Sub Add(ByVal NewPessoa As Pessoa)

        Me.List.Add(NewPessoa)



        ObjCodigoHashtable.Add(NewPessoa.Codigo.ToLower, NewPessoa)

        ObjNomeHashtable.Add(NewPessoa.Nome.ToLower, NewPessoa)



        _count = Me.List.Count

    End Sub



    Public Sub Remove(ByVal oldPessoa As Pessoa)

        Me.List.Remove(oldPessoa)



        ObjCodigoHashtable.Remove(oldPessoa.Codigo.ToLower)

        ObjNomeHashtable.Remove(oldPessoa.Nome.ToLower)

    End Sub



    Default Public Property item(ByVal index As Integer) As Pessoa

        Get

            Return Me.List.Item(index)

        End Get

        Set(ByVal value As Pessoa)

            Me.List.Item(index) = value

        End Set

    End Property



    Default Public ReadOnly Property item(ByVal Codigo As String) As Pessoa

        Get

            Return ObjCodigoHashtable.Item(Codigo.ToLower)

        End Get



    End Property

    Public ReadOnly Property itemByNome(ByVal Nome As String) As Pessoa

        Get

            Return ObjNomeHashtable.Item(Nome.ToLower)

        End Get



    End Property

    Public ReadOnly Property ExistsNome(ByVal Nome As String) As Boolean

        Get

            If IsNothing(ObjNomeHashtable.Item(Nome.ToLower)) Then



                Return False

            Else

                Return True

            End If

        End Get



    End Property





    Private ReadOnly Property CodigoHashtable() As Hashtable

        Get

            Return ObjCodigoHashtable

        End Get



    End Property

    Private ReadOnly Property NomeHashtable() As Hashtable

        Get

            Return ObjNomeHashtable

        End Get



    End Property



    Public Shadows Sub clear()

        MyBase.Clear()

        CodigoHashtable.Clear()

        NomeHashtable.Clear()



    End Sub



    Public Shadows Sub RemoveAt(ByVal index As Integer)

        Remove(item(index))



    End Sub
End Class
