﻿Public Class Pessoa



    Implements IDisposable



    Private L_Codigo As String = ""

    Private L_Nome As String = ""

    Private L_DataNasc As Date = Nothing



    Public Sub New()



    End Sub



    Public Sub New(ByVal Codigo As String)

        L_Codigo = Codigo

    End Sub



    Public Sub New(ByVal Codigo As String, ByVal nome As String)

        L_Codigo = Codigo

        L_Nome = nome

    End Sub



    Public Sub New(ByVal Codigo As String, ByVal nome As String, ByVal DataNasc As Date)

        L_Codigo = Codigo

        L_Nome = nome

        L_DataNasc = DataNasc

    End Sub



    Public Property Codigo() As String

        Get

            Return L_Codigo

        End Get

        Set(ByVal value As String)

            L_Codigo = value

        End Set

    End Property



    Public Property Nome() As String

        Get

            Return L_Nome

        End Get

        Set(ByVal value As String)

            L_Nome = value

        End Set

    End Property



    Public Property DataNascimento() As Date

        Get

            Return L_DataNasc

        End Get

        Set(ByVal value As Date)

            L_DataNasc = value

        End Set

    End Property



    Public ReadOnly Property Idade() As Integer

        Get

            Return DateDiff(DateInterval.Year, L_DataNasc, Today)

        End Get



    End Property



    Private disposedValue As Boolean = False        ' To detect redundant calls



    ' IDisposable

    Protected Overridable Sub Dispose(ByVal disposing As Boolean)

        If Not Me.disposedValue Then

            If disposing Then

                ' TODO: free other state (managed objects).

            End If



            ' TODO: free your own state (unmanaged objects).

            ' TODO: set large fields to null.

        End If

        Me.disposedValue = True

    End Sub



#Region " IDisposable Support "

    ' This code added by Visual Basic to correctly implement the disposable pattern.

    Public Sub Dispose() Implements IDisposable.Dispose

        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.

        Dispose(True)

        GC.SuppressFinalize(Me)

    End Sub

#End Region



End Class